package org.dromara.work.service.impl;

import com.baomidou.mybatisplus.core.metadata.IPage;
import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Service;
import org.dromara.work.domain.bo.TpAppealsBo;
import org.dromara.work.domain.vo.TpAppealsVo;
import org.dromara.work.domain.TpAppeals;
import org.dromara.work.mapper.TpAppealsMapper;
import org.dromara.work.service.ITpAppealsService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 订单投诉Service业务层处理
 *
 * @author Maosw
 * @date 2025-04-12
 */
@RequiredArgsConstructor
@Service
public class TpAppealsServiceImpl implements ITpAppealsService {

    private final TpAppealsMapper baseMapper;

    /**
     * 查询订单投诉
     *
     * @param id 主键
     * @return 订单投诉
     */
    @Override
    public TpAppealsVo queryById(Long id){
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询订单投诉列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 订单投诉分页列表
     */
    @Override
    public TableDataInfo<TpAppealsVo> queryPageList(TpAppealsBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<TpAppeals> lqw = buildQueryWrapper(bo);
        Page<TpAppealsVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询订单投诉分页列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 订单投诉分页列表
     */
    @Override
    public IPage<TpAppealsVo> selectPageList(TpAppealsBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<TpAppeals> lqw = buildQueryWrapper(bo);
        Page<TpAppealsVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return result;
    }

    /**
     * 查询符合条件的订单投诉列表
     *
     * @param bo 查询条件
     * @return 订单投诉列表
     */
    @Override
    public List<TpAppealsVo> queryList(TpAppealsBo bo) {
        LambdaQueryWrapper<TpAppeals> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<TpAppeals> buildQueryWrapper(TpAppealsBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<TpAppeals> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(TpAppeals::getId);
        lqw.eq(bo.getOrderId() != null, TpAppeals::getOrderId, bo.getOrderId());
        lqw.eq(bo.getUserId() != null, TpAppeals::getUserId, bo.getUserId());
        lqw.eq(bo.getToUserId() != null, TpAppeals::getToUserId, bo.getToUserId());
        lqw.eq(bo.getType() != null, TpAppeals::getType, bo.getType());
        lqw.eq(bo.getStatus() != null, TpAppeals::getStatus, bo.getStatus());
        lqw.between(params.get("beginHandledTime") != null && params.get("endHandledTime") != null,
            TpAppeals::getHandledTime ,params.get("beginHandledTime"), params.get("endHandledTime"));
        lqw.between(params.get("beginCreateTime") != null && params.get("endCreateTime") != null,
            TpAppeals::getCreateTime ,params.get("beginCreateTime"), params.get("endCreateTime"));
        return lqw;
    }

    /**
     * 新增订单投诉
     *
     * @param bo 订单投诉
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(TpAppealsBo bo) {
        TpAppeals add = MapstructUtils.convert(bo, TpAppeals.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改订单投诉
     *
     * @param bo 订单投诉
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(TpAppealsBo bo) {
        TpAppeals update = MapstructUtils.convert(bo, TpAppeals.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(TpAppeals entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除订单投诉信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
